import { type DocumentNode } from "graphql";
import { ApolloLink } from "@apollo/client/link/core";
type SHA256Function = (...args: any[]) => string | PromiseLike<string>;
export declare function generatePersistedQueryIdsAtRuntime(options: {
    sha256: SHA256Function;
}): {
    generateHash: (query: DocumentNode) => Promise<string>;
    disable: () => boolean;
};
export declare function sortTopLevelDefinitions(query: DocumentNode): DocumentNode;
export interface PersistedQueryManifestForGeneratingPersistedQueryIds {
    operations: {
        id: string;
        name: string;
    }[];
}
export interface GeneratePersistedQueryIdsFromManifestOptions {
    loadManifest: () => Promise<PersistedQueryManifestForGeneratingPersistedQueryIds>;
}
export declare function generatePersistedQueryIdsFromManifest(options: GeneratePersistedQueryIdsFromManifestOptions): {
    generateHash: (document: DocumentNode) => Promise<string>;
    disable: () => boolean;
};
export interface PersistedQueryManifestForVerification {
    operations: {
        name: string;
        body: string;
    }[];
}
export interface CreatePersistedQueryManifestVerificationLinkOptions {
    loadManifest: () => Promise<PersistedQueryManifestForVerification>;
    onAnonymousOperation?: (options: {
        body: string;
    }) => void;
    onMultiOperationDocument?: (options: {
        body: string;
    }) => void;
    onNoOperationsDocument?: (options: {
        body: string;
    }) => void;
    onUnknownOperationName?: (options: {
        operationName: string;
        body: string;
    }) => void;
    onDifferentBody?: (options: {
        operationName: string;
        manifestBody: string;
        actualBody: string;
    }) => void;
}
export declare function createPersistedQueryManifestVerificationLink(options: CreatePersistedQueryManifestVerificationLinkOptions): ApolloLink;
export {};
//# sourceMappingURL=index.d.ts.map